Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_gettemplatevars.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_gettemplatevars.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_gettemplatevars.php	(revision )
@@ -0,0 +1,114 @@
+<?php
+
+/**
+ * Smarty Method GetTemplateVars
+ *
+ * Smarty::getTemplateVars() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_GetTemplateVars
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+    /**
+     * Returns a single or all template variables
+     *
+     * @api  Smarty::getTemplateVars()
+     * @link http://www.smarty.net/docs/en/api.get.template.vars.tpl
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  string                                                 $varName        variable name or null
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $_ptr           optional pointer to data object
+     * @param  bool                                                   $searchParents include parent templates?
+     *
+     * @return mixed variable value or or array of variables
+     */
+    public function getTemplateVars(Smarty_Internal_Data $data, $varName = null, Smarty_Internal_Data $_ptr = null, $searchParents = true)
+    {
+        if (isset($varName)) {
+            $_var = $this->_getVariable($data, $varName, $_ptr, $searchParents, false);
+            if (is_object($_var)) {
+                return $_var->value;
+            } else {
+                return null;
+            }
+        } else {
+            $_result = array();
+            if ($_ptr === null) {
+                $_ptr = $data;
+            }
+            while ($_ptr !== null) {
+                foreach ($_ptr->tpl_vars AS $key => $var) {
+                    if (!array_key_exists($key, $_result)) {
+                        $_result[$key] = $var->value;
+                    }
+                }
+                // not found, try at parent
+                if ($searchParents) {
+                    $_ptr = $_ptr->parent;
+                } else {
+                    $_ptr = null;
+                }
+            }
+            if ($searchParents && isset(Smarty::$global_tpl_vars)) {
+                foreach (Smarty::$global_tpl_vars AS $key => $var) {
+                    if (!array_key_exists($key, $_result)) {
+                        $_result[$key] = $var->value;
+                    }
+                }
+            }
+            return $_result;
+        }
+    }
+
+    /**
+     * gets the object of a Smarty variable
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param string                                                 $varName       the name of the Smarty variable
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $_ptr           optional pointer to data object
+     * @param bool                                                   $searchParents search also in parent data
+     * @param bool                                                    $errorEnable
+     *
+     * @return \Smarty_Variable
+     */
+    public function _getVariable(Smarty_Internal_Data $data, $varName, Smarty_Internal_Data $_ptr = null, $searchParents = true, $errorEnable = true)
+    {
+        if ($_ptr === null) {
+            $_ptr = $data;
+        }
+        while ($_ptr !== null) {
+            if (isset($_ptr->tpl_vars[$varName])) {
+                // found it, return it
+                return $_ptr->tpl_vars[$varName];
+            }
+            // not found, try at parent
+            if ($searchParents) {
+                $_ptr = $_ptr->parent;
+            } else {
+                $_ptr = null;
+            }
+        }
+        if (isset(Smarty::$global_tpl_vars[$varName])) {
+            // found it, return it
+            return Smarty::$global_tpl_vars[$varName];
+        }
+        /* @var \Smarty $smarty */
+        $smarty = isset($data->smarty) ? $data->smarty : $data;
+        if ($smarty->error_unassigned && $errorEnable) {
+            // force a notice
+            $x = $$varName;
+        }
+
+        return new Smarty_Undefined_Variable;
+    }
+
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_setautoloadfilters.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_setautoloadfilters.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_setautoloadfilters.php	(revision )
@@ -0,0 +1,70 @@
+<?php
+
+/**
+ * Smarty Method SetAutoloadFilters
+ *
+ * Smarty::setAutoloadFilters() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_SetAutoloadFilters
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Valid filter types
+     *
+     * @var array
+     */
+    private $filterTypes = array('pre' => true, 'post' => true, 'output' => true, 'variable' => true);
+
+    /**
+     * Set autoload filters
+     *
+     * @api Smarty::setAutoloadFilters()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  array                                                          $filters filters to load automatically
+     * @param  string                                                         $type    "pre", "output", … specify the
+     *                                                                                 filter type to set. Defaults to
+     *                                                                                 none treating $filters' keys as
+     *                                                                                 the appropriate types
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function setAutoloadFilters(Smarty_Internal_TemplateBase $obj, $filters, $type = null)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if ($type !== null) {
+            $this->_checkFilterType($type);
+            $smarty->autoload_filters[$type] = (array) $filters;
+        } else {
+            foreach ((array) $filters as $type => $value) {
+                $this->_checkFilterType($type);
+            }
+            $smarty->autoload_filters = (array) $filters;
+        }
+        return $obj;
+    }
+
+    /**
+     * Check if filter type is valid
+     *
+     * @param string $type
+     *
+     * @throws \SmartyException
+     */
+    public function _checkFilterType($type)
+    {
+        if (!isset($this->filterTypes[$type])) {
+            throw new SmartyException("Illegal filter type \"{$type}\"");
+        }
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/modifiercompiler.count_words.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.count_words.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.count_words.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_extends.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_extends.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_extends.php	(revision )
@@ -15,7 +15,7 @@
  * @package    Smarty
  * @subpackage Compiler
  */
-class Smarty_Internal_Compile_Extends extends Smarty_Internal_CompileBase
+class Smarty_Internal_Compile_Extends extends Smarty_Internal_Compile_Shared_Inheritance
 {
     /**
      * Attribute definition: Overwrites base class.
@@ -24,7 +24,16 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('file');
+
     /**
+     * Array of names of optional attribute required by tag
+     * use array('_any') if there is no restriction of attributes names
+     *
+     * @var array
+     */
+    public $optional_attributes = array('extends_resource');
+
+    /**
      * Attribute definition: Overwrites base class.
      *
      * @var array
@@ -33,53 +42,93 @@
     public $shorttag_order = array('file');
 
     /**
-     * Compiles code for the {extends} tag
+     * Compiles code for the {extends} tag extends: resource
      *
-     * @param array  $args     array with attributes from parser
+     * @param array                                 $args     array with attributes from parser
-     * @param object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
+     * @throws \SmartyException
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
         if ($_attr['nocache'] === true) {
-            $compiler->trigger_template_error('nocache option not allowed', $compiler->lex->taglineno);
+            $compiler->trigger_template_error('nocache option not allowed', $compiler->parser->lex->line - 1);
         }
         if (strpos($_attr['file'], '$_tmp') !== false) {
-            $compiler->trigger_template_error('illegal value for file attribute', $compiler->lex->taglineno);
+            $compiler->trigger_template_error('illegal value for file attribute', $compiler->parser->lex->line - 1);
         }
-
-        $name = $_attr['file'];
-        /** @var Smarty_Internal_Template $_smarty_tpl
-         * used in evaluated code
-         */
-        $_smarty_tpl = $compiler->template;
-        eval("\$tpl_name = $name;");
-        // create template object
-        $_template = new $compiler->smarty->template_class($tpl_name, $compiler->smarty, $compiler->template);
-        // check for recursion
-        $uid = $_template->source->uid;
-        if (isset($compiler->extends_uid[$uid])) {
-            $compiler->trigger_template_error("illegal recursive call of \"$include_file\"", $compiler->lex->line - 1);
-        }
-        $compiler->extends_uid[$uid] = true;
-        if (empty($_template->source->components)) {
-            array_unshift($compiler->sources, $_template->source);
+        // add code to initialize inheritance
+        $this->registerInit($compiler, true);
+        $file = trim($_attr['file'], '\'"');
+        if (strlen($file) > 8 && substr($file, 0, 8) == 'extends:') {
+            // generate code for each template
+            $files = array_reverse(explode('|', substr($file, 8)));
+            $i = 0;
+            foreach ($files as $file) {
+                if ($file[0] == '"') {
+                    $file = trim($file, '".');
-        } else {
+                } else {
-            foreach ($_template->source->components as $source) {
-                array_unshift($compiler->sources, $source);
-                $uid = $source->uid;
-                if (isset($compiler->extends_uid[$uid])) {
-                    $compiler->trigger_template_error("illegal recursive call of \"{$source->filepath}\"", $compiler->lex->line - 1);
+                    $file = "'{$file}'";
                 }
-                $compiler->extends_uid[$uid] = true;
+                $i ++;
+                if ($i == count($files) && isset($_attr['extends_resource'])) {
+                    $this->compileEndChild($compiler);
-            }
+                }
+                $this->compileInclude($compiler, $file);
-        }
+            }
-        unset ($_template);
-        $compiler->inheritance_child = true;
-        $compiler->lex->yypushstate(Smarty_Internal_Templatelexer::CHILDBODY);
+            if (!isset($_attr['extends_resource'])) {
+                $this->compileEndChild($compiler);
+            }
+        } else {
+            $this->compileEndChild($compiler);
+            $this->compileInclude($compiler, $_attr['file']);
+        }
+        $compiler->has_code = false;
         return '';
+    }
+
+    /**
+     * Add code for inheritance endChild() method to end of template
+     *
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     */
+    private function compileEndChild(Smarty_Internal_TemplateCompilerBase $compiler)
+    {
+        $compiler->parser->template_postfix[] = new Smarty_Internal_ParseTree_Tag($compiler->parser,
+                                                                                  "<?php \$_smarty_tpl->ext->_inheritance->endChild(\$_smarty_tpl);\n?>\n");
+    }
+
+    /**
+     * Add code for including subtemplate to end of template
+     *
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     * @param  string                               $file subtemplate name
+     */
+    private function compileInclude(Smarty_Internal_TemplateCompilerBase $compiler, $file)
+    {
+        $compiler->parser->template_postfix[] = new Smarty_Internal_ParseTree_Tag($compiler->parser,
+                                                                                  $compiler->compileTag('include',
+                                                                                                        array($file,
+                                                                                                              array('scope' => 'parent'))));
+    }
+
+    /**
+     * Create source code for {extends} from source components array
+     *
+     * @param []\Smarty_Internal_Template_Source $components
+     *
+     * @return string
+     */
+    public static function extendsSourceArrayCode($components)
+    {
+        $resources = array();
+        foreach ($components as $source) {
+            $resources[] = $source->resource;
+        }
+        return '{extends file=\'extends:' . join('|', $resources) . '\' extends_resource=true}';
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_ldelim.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_ldelim.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_ldelim.php	(revision )
@@ -20,16 +20,17 @@
      * Compiles code for the {ldelim} tag
      * This tag does output the left delimiter
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         $_attr = $this->getAttributes($compiler, $args);
         if ($_attr['nocache'] === true) {
-            $compiler->trigger_template_error('nocache option not allowed', $compiler->lex->taglineno);
+            $compiler->trigger_template_error('nocache option not allowed', null, true);
         }
         // this tag does not return compiled code
         $compiler->has_code = true;
Index: src/includes/classes/Smarty/plugins/modifier.capitalize.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifier.capitalize.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifier.capitalize.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/plugins/modifier.date_format.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifier.date_format.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifier.date_format.php	(revision )
@@ -33,7 +33,7 @@
         $format = Smarty::$_DATE_FORMAT;
     }
     /**
-     * Include the {@link shared.make_timestamp.php} plugin
+     * require_once the {@link shared.make_timestamp.php} plugin
      */
     require_once(SMARTY_PLUGINS_DIR . 'shared.make_timestamp.php');
     if ($string != '' && $string != '0000-00-00' && $string != '0000-00-00 00:00:00') {
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_debug.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_debug.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_debug.php	(revision )
@@ -34,8 +34,8 @@
         $compiler->tag_nocache = true;
 
         // display debug template
-        $_output = "<?php \$_smarty_tpl->smarty->loadPlugin('Smarty_Internal_Debug'); Smarty_Internal_Debug::display_debug(\$_smarty_tpl); ?>";
-
+        $_output = "<?php \$_smarty_debug = new Smarty_Internal_Debug;\n \$_smarty_debug->display_debug(\$_smarty_tpl);\n";
+        $_output .= "unset(\$_smarty_debug);\n?>";
         return $_output;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_include_php.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_include_php.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_include_php.php	(revision )
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('file');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -30,6 +31,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $shorttag_order = array('file');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -41,13 +43,14 @@
     /**
      * Compiles code for the {include_php} tag
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
-     * @throws SmartyException
-     * @return string compiled code
+     * @return string
+     * @throws \SmartyCompilerException
+     * @throws \SmartyException
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         if (!($compiler->smarty instanceof SmartyBC)) {
             throw new SmartyException("{include_php} is deprecated, use SmartyBC class to enable");
@@ -60,9 +63,10 @@
          */
         $_smarty_tpl = $compiler->template;
         $_filepath = false;
-        eval('$_file = ' . $_attr['file'] . ';');
+        $_file = null;
+        eval('$_file = @' . $_attr['file'] . ';');
         if (!isset($compiler->smarty->security_policy) && file_exists($_file)) {
-            $_filepath = $_file;
+            $_filepath = $compiler->smarty->_realpath($_file, true);
         } else {
             if (isset($compiler->smarty->security_policy)) {
                 $_dir = $compiler->smarty->security_policy->trusted_dir;
@@ -71,16 +75,16 @@
             }
             if (!empty($_dir)) {
                 foreach ((array) $_dir as $_script_dir) {
-                    $_script_dir = rtrim($_script_dir, '/\\') . DS;
-                    if (file_exists($_script_dir . $_file)) {
-                        $_filepath = $_script_dir . $_file;
+                    $_path = $compiler->smarty->_realpath($_script_dir . DS . $_file, true);
+                    if (file_exists($_path)) {
+                        $_filepath = $_path;
                         break;
                     }
                 }
             }
         }
         if ($_filepath == false) {
-            $compiler->trigger_template_error("{include_php} file '{$_file}' is not readable", $compiler->lex->taglineno);
+            $compiler->trigger_template_error("{include_php} file '{$_file}' is not readable", null, true);
         }
 
         if (isset($compiler->smarty->security_policy)) {
@@ -99,7 +103,7 @@
         }
 
         if (isset($_assign)) {
-            return "<?php ob_start(); include{$_once} ('{$_filepath}'); \$_smarty_tpl->assign({$_assign},ob_get_contents()); ob_end_clean();?>";
+            return "<?php ob_start();\ninclude{$_once} ('{$_filepath}');\n\$_smarty_tpl->assign({$_assign},ob_get_clean());\n?>";
         } else {
             return "<?php include{$_once} ('{$_filepath}');?>\n";
         }
Index: src/includes/classes/Smarty/SmartyBC.class.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/SmartyBC.class.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/SmartyBC.class.php	(revision )
@@ -48,6 +48,13 @@
     public $_version = self::SMARTY_VERSION;
 
     /**
+     * This is an array of directories where trusted php scripts reside.
+     *
+     * @var array
+     */
+    public $trusted_dir = array();
+
+    /**
      * Initialize new SmartyBC object
      *
      * @param array $options options to set during initialization, e.g. array( 'forceCompile' => false )
@@ -55,8 +62,6 @@
     public function __construct(array $options = array())
     {
         parent::__construct($options);
-        // register {php} tag
-        $this->registerPlugin('block', 'php', 'smarty_php_tag');
     }
 
     /**
@@ -118,10 +123,10 @@
     /**
      * Registers object to be used in templates
      *
-     * @param string  $object      name of template object
+     * @param string  $object        name of template object
-     * @param object  $object_impl the referenced PHP object to register
+     * @param object  $object_impl   the referenced PHP object to register
-     * @param array   $allowed     list of allowed methods (empty = all)
+     * @param array   $allowed       list of allowed methods (empty = all)
-     * @param boolean $smarty_args smarty argument format, else traditional
+     * @param boolean $smarty_args   smarty argument format, else traditional
      * @param array   $block_methods list of methods that are block format
      *
      * @throws SmartyException
@@ -448,26 +453,9 @@
      */
     public function trigger_error($error_msg, $error_type = E_USER_WARNING)
     {
-	    $msg = htmlentities_wrapper($error_msg);
+        $msg = htmlentities_wrapper($error_msg);
         trigger_error("Smarty error: $msg", $error_type);
     }
-}
-
-/**
- * Smarty {php}{/php} block function
- *
- * @param array   $params   parameter list
- * @param string  $content  contents of the block
- * @param object  $template template object
- * @param boolean &$repeat  repeat flag
- *
- * @return string content re-formatted
- */
-function smarty_php_tag($params, $content, $template, &$repeat)
-{
-    eval($content);
-
-    return '';
 }
 
 MainFactory::load_origin_class('Smarty');
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_registered_block.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_registered_block.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_registered_block.php	(revision )
@@ -27,14 +27,14 @@
     /**
      * Compiles code for the execution of a block function
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                       $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                       $parameter array with compilation parameter
-     * @param  string $tag       name of block function
+     * @param  string                                      $tag       name of block function
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter, $tag)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter, $tag)
     {
         if (!isset($tag[5]) || substr($tag, - 5) != 'close') {
             // opening tag of block plugin
@@ -69,11 +69,11 @@
             $function = $tag_info[0];
             // compile code
             if (!is_array($function)) {
-                $output = "<?php \$_smarty_tpl->smarty->_tag_stack[] = array('{$tag}', {$_params}); \$_block_repeat=true; echo {$function}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
+                $output = "<?php \$_smarty_tpl->smarty->_cache['tag_stack'][] = array('{$tag}', {$_params}); \$_block_repeat=true; echo {$function}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
             } elseif (is_object($function[0])) {
-                $output = "<?php \$_smarty_tpl->smarty->_tag_stack[] = array('{$tag}', {$_params}); \$_block_repeat=true; echo \$_smarty_tpl->smarty->registered_plugins['block']['{$tag}'][0][0]->{$function[1]}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
+                $output = "<?php \$_smarty_tpl->smarty->_cache['tag_stack'][] = array('{$tag}', {$_params}); \$_block_repeat=true; echo \$_smarty_tpl->smarty->registered_plugins['block']['{$tag}'][0][0]->{$function[1]}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
             } else {
-                $output = "<?php \$_smarty_tpl->smarty->_tag_stack[] = array('{$tag}', {$_params}); \$_block_repeat=true; echo {$function[0]}::{$function[1]}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
+                $output = "<?php \$_smarty_tpl->smarty->_cache['tag_stack'][] = array('{$tag}', {$_params}); \$_block_repeat=true; echo {$function[0]}::{$function[1]}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
             }
         } else {
             // must endblock be nocache?
@@ -95,14 +95,22 @@
                 $mod_pre = $mod_post = '';
             } else {
                 $mod_pre = ' ob_start(); ';
-                $mod_post = 'echo ' . $compiler->compileTag('private_modifier', array(), array('modifierlist' => $parameter['modifier_list'], 'value' => 'ob_get_clean()')) . ';';
+                $mod_post = 'echo ' .
+                    $compiler->compileTag('private_modifier', array(), array('modifierlist' => $parameter['modifier_list'],
+                                                                             'value'        => 'ob_get_clean()')) . ';';
             }
             if (!is_array($function)) {
-                $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre . " echo {$function}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat);" . $mod_post . " } array_pop(\$_smarty_tpl->smarty->_tag_stack);?>";
+                $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre .
+                    " echo {$function}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat);" . $mod_post .
+                    " } array_pop(\$_smarty_tpl->smarty->_cache['tag_stack']);?>";
             } elseif (is_object($function[0])) {
-                $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre . " echo \$_smarty_tpl->smarty->registered_plugins['block']['{$base_tag}'][0][0]->{$function[1]}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat); " . $mod_post . "} array_pop(\$_smarty_tpl->smarty->_tag_stack);?>";
+                $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre .
+                    " echo \$_smarty_tpl->smarty->registered_plugins['block']['{$base_tag}'][0][0]->{$function[1]}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat); " .
+                    $mod_post . "} array_pop(\$_smarty_tpl->smarty->_cache['tag_stack']);?>";
             } else {
-                $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre . " echo {$function[0]}::{$function[1]}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat); " . $mod_post . "} array_pop(\$_smarty_tpl->smarty->_tag_stack);?>";
+                $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre .
+                    " echo {$function[0]}::{$function[1]}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat); " .
+                    $mod_post . "} array_pop(\$_smarty_tpl->smarty->_cache['tag_stack']);?>";
             }
         }
 
